<?xml version="1.0" encoding="UTF-8"?>
<!--
Pantalla inicial de radicacion del proceso express de actualzacion

19-08-2015

@author felipe.cadena
@mb RadicacionActualizacionMB

-->
<!DOCTYPE html>
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                template="/templates/generalCU.xhtml">

    <style>
        .datosSolicitanteStyle{
            width: 250px;

        }

    </style>
    <ui:define name="title">.::Sistema Nacional Catastral::. .::Radicación actualización::.</ui:define>
    <ui:define name="content">
        <p:ajaxStatus onstart="statusDialog.show();"
                      onsuccess="statusDialog.hide();" onerror="statusDialog.hide();" />
        <p:focus />

        <h:form id="datosActualizacionForm">
            <p:messages id="msgsGS" showDetail="false" globalOnly="false" />

            <p:fieldset legend="Validar información" toggleable="true"
                        toggleSpeed="500" >

                <h:panelGrid columns="4" cellpadding="2" width="25%">
                    <h:outputLabel for="consultaPredioDepartamento"
                                   value="Departamento: " styleClass="outputLabelStyle" />
                    <h:selectOneMenu id="consultaPredioDepartamento"
                                     label="Departamento"
                                     value="#{radicacionActualizacion.departamentoSeleccionado}">
                        <f:selectItem itemLabel="Todos" itemValue="" />
                        <f:selectItems
                            value="#{radicacionActualizacion.departamentosItemList}" />
                        <p:ajax listener="#{radicacionActualizacion.actualizarMunicipiosListener}"
                                update="consultaPredioMunicipio" onstart="statusDialog2.show();"
                                oncomplete="statusDialog2.hide();" />
                    </h:selectOneMenu>

                    <h:outputLabel for="consultaPredioMunicipio" value="Municipio: "
                                   styleClass="outputLabelStyle" />
                    <h:selectOneMenu id="consultaPredioMunicipio" label="Municipio"
                                     value="#{radicacionActualizacion.municipioSeleccionado}">
                        <f:selectItem itemLabel="Todos" itemValue="" />
                        <f:selectItems value="#{radicacionActualizacion.municipiosItemList}" />

                        <p:ajax event="change" 
                                listener="#{radicacionActualizacion.seleccionarMunicipioListener}" 
                                update=":datosActualizacionForm:panelBtns, buscarBtn"/>

                    </h:selectOneMenu>
                </h:panelGrid>


                <p:spacer height="13" width="13" />
                <p:outputPanel layout="block" style="text-align:left">

                    <p:spacer height="13" width="13" />

                    <p:commandButton value="Buscar" widgetVar="buscarBtn" id="buscarBtn"
                                     icon="ui-icon ui-icon-search" 
                                     update="procesosActualizacionDT"
                                     disabled="#{!radicacionActualizacion.banderaValidarInformacion}"
                                     action="#{radicacionActualizacion.buscar}"
                                     onstart="statusDialog2.show();" onsuccess="statusDialog2.hide();" />
                    <p:spacer height="13" width="13" />




                </p:outputPanel>

                <p:spacer height="13" width="13" />

                <p:dataTable id="procesosActualizacionDT"
                             value="#{radicacionActualizacion.procesosActualizacion}" var="proceso"
                             paginator="true" rows="10" rowKey="#{proceso.id}"
                             paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {PageLinks} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                             rowsPerPageTemplate="5,10,15" paginatorPosition="bottom"
                             selectionMode="single"
                             selection="#{radicacionActualizacion.procesoActualizacionSeleccionado}"

                             emptyMessage="No se encontraron procesos activos.">

                    <!--                    <p:ajax event="rowSelect" 
                                                listener="#{radicacionActualizacion.seleccionarProcesoListener}" 
                                                update=":datosActualizacionForm"/>
                                        <p:ajax event="rowUnselect" 
                                                listener="#{radicacionActualizacion.seleccionarProcesoListener}" 
                                                update=":datosActualizacionForm"/>-->

                    <p:column headerText="Departamento">
                        <h:outputText value="#{proceso.departamento.nombre}" 
                                      styleClass="outputTextStyleInTable"/>
                    </p:column>

                    <p:column headerText="Municipio">
                        <h:outputText value="#{proceso.municipio.nombre}" 
                                      styleClass="outputTextStyleInTable"/>
                    </p:column>
                    <p:column headerText="Archivo"  sortBy="#{proceso.archivoAlfanumerico}">
                        <h:outputText value="#{proceso.archivoAlfanumerico}" 
                                      styleClass="outputTextStyleInTable"/>
                    </p:column>
                    <p:column headerText="Número solicitud">
                        <p:commandLink  update=":datosActualizacionForm, :infoRadicacionForm"
                                        onstart="statusDialog2.show();"
                                        oncomplete="statusDialog2.hide();radicarInfoWV.show();"
                                        action="#{radicacionActualizacion.mostrarDetalleRadicacion}">
                            <h:outputText value="#{proceso.solicitud.numero}" 
                                          styleClass="commandLinkStyleInTable"/>
                            <f:setPropertyActionListener value="#{proceso}"
                                                         target="#{radicacionActualizacion.procesoActualizacionSeleccionado}" />
                        </p:commandLink>
                    </p:column>
                    <p:column headerText="Estado"  sortBy="#{proceso.estado}">
                        <h:outputText value="#{proceso.estado}" 
                                      styleClass="outputTextStyleInTable"/>
                    </p:column>
                    <p:column headerText="Observaciones">
                        <h:outputText value="#{proceso.observaciones}" 
                                      styleClass="outputTextStyleInTable"/>
                    </p:column>
                    <p:column headerText="Opciones validación">

                        <p:commandButton  immediate="true" ajax="false"
                                          disabled="#{!(proceso.estado == 'VALIDACION_FALLIDA')}"
                                          title="Reporte de inconsistencias"
                                          id="descargarDocumentosBtn" icon="ui-icon-calculator">
                            <f:setPropertyActionListener value="#{proceso}"
                                                         target="#{radicacionActualizacion.procesoActualizacionSeleccionado}" />
                            <p:fileDownload value="#{radicacionActualizacion.reporteInconsistencias}"/>
                        </p:commandButton>

                        <p:spacer height="0" width="5" />
                        <p:commandButton title="Eliminar" 
                                         disabled="#{!(proceso.estado == 'VALIDACION_EXITOSA' or proceso.estado == 'VALIDACION_FALLIDA' or proceso.estado == 'VALIDACION_EXITOSA_TYR')}"
                                         action="#{radicacionActualizacion.eliminarProcesoActualizacion}"
                                         onstart="statusDialog2.show();"
                                         update=":datosActualizacionForm"
                                         oncomplete="statusDialog2.hide();"
                                         immediate="true" ajax="true" icon="ui-icon-trash">
                            <f:setPropertyActionListener value="#{proceso}"
                                                         target="#{radicacionActualizacion.procesoActualizacionSeleccionado}" />
                        </p:commandButton>
                        <p:spacer height="0" width="5" />
                        <p:commandButton title="Actualizar archivos" rendered="false"
                                         disabled="#{!(proceso.estado == 'CARGUE'or proceso.estado == 'VALIDACION_FALLIDA')}"
                                         action="#{radicacionActualizacion.actualizarArchivos}"
                                         onstart="statusDialog2.show();"
                                         update=":datosActualizacionForm"
                                         oncomplete="statusDialog2.hide(); cargarArchivosWV.show();"
                                         immediate="true" ajax="true" icon="ui-icon-document">
                            <f:setPropertyActionListener value="#{proceso}"
                                                         target="#{radicacionActualizacion.procesoActualizacionSeleccionado}" />
                        </p:commandButton>

                        <p:spacer height="13" width="13" />
                    </p:column>
                    <p:column headerText="Opciones radicación">

                        <p:commandButton title="Radicar trámites" 
                                         icon="ui-icon-circle-arrow-e"  
                                         update=":datosActualizacionForm, :infoRadicacionForm"
                                         disabled="#{!(proceso.estado == 'VALIDACION_EXITOSA' or proceso.estado == 'VALIDACION_EXITOSA_TYR')}"
                                         action="#{radicacionActualizacion.iniciarRadicacion}"
                                         onstart="statusDialog2.show();" onsuccess="statusDialog2.hide();radicarInfoWV.show();" >
                            <f:setPropertyActionListener value="#{proceso}"
                                                         target="#{radicacionActualizacion.procesoActualizacionSeleccionado}" />
                        </p:commandButton>
                        <p:spacer height="13" width="13" />
                    </p:column>

                </p:dataTable>

                <p:spacer height="20" width="13" />

                <p:outputPanel layout="block" style="text-align:left" id="panelBtns">

                    <p:spacer height="13" width="13" />

                    <p:commandButton value="Nuevo proceso de actualización" 
                                     icon="ui-icon-check" 
                                     update=":cargarArchivosForm"
                                     process="@this"
                                     onstart="statusDialog2.show(); " onsuccess="statusDialog2.hide();cargarArchivosWV.show();" >
                        <f:setPropertyActionListener target="#{radicacionActualizacion.banderaZipCargado}" value="false"/>
                    </p:commandButton>
                    <p:spacer height="13" width="13" />

                    <p:commandButton value="Validar información" 
                                     disabled="#{!radicacionActualizacion.banderaValidarInformacion}"
                                     icon="ui-icon-check" 
                                     update=":validarInfoForm, msgsGS"
                                     action="#{radicacionActualizacion.iniciarValidacion}"
                                     onstart="statusDialog2.show(); " onsuccess="statusDialog2.hide();" />
                    <p:spacer height="13" width="13" />

                    <p:commandButton value="Cerrar" 
                                     icon="ui-icon-circle-close" 
                                     action="#{radicacionActualizacion.cerrar}"
                                     onstart="statusDialog2.show();" onsuccess="statusDialog2.hide();" />
                    <p:spacer height="13" width="13" />




                </p:outputPanel>
                <p:spacer height="20" width="13" />

            </p:fieldset>
            <p:spacer height="20" width="13" />



            <p:outputPanel layout="block" style="text-align:right">

                <p:spacer height="40" width="13" />
                <p:commandButton value="Cerrar" 
                                 icon="ui-icon-circle-close" 
                                 action="#{radicacionActualizacion.cerrar}"
                                 onstart="statusDialog2.show();" onsuccess="statusDialog2.hide();" />
                <p:spacer height="0" width="20" />

            </p:outputPanel>
            <p:spacer height="40" width="13" />

        </h:form>


        <p:dialog header="Validar información" dynamic="true"
                  widgetVar="validarInfoWV" modal="true" appendToBody="true"
                  resizable="true" position="center" width="500" height="180">
            <h:form id="validarInfoForm"> 



                <h:panelGrid columns="2" cellpadding="10">
                    <h:outputLabel value="Archivo alfanumérico" 
                                   styleClass="outputLabelStyle" />
                    <h:inputText value="#{radicacionActualizacion.archivoAlfanumerico}"
                                 required="true"
                                 requiredMessage="Se debe ingresar el nombre del archivo alfanumérico"
                                 style="width: 300px;"/>

                    <h:outputLabel value="Archivo geográfico" 
                                   styleClass="outputLabelStyle" />
                    <h:inputText value="#{radicacionActualizacion.archivoGeografico}"
                                 required="true"
                                 requiredMessage="Se debe ingresar el nombre del archivo geográfico"
                                 style="width: 300px;" />

                </h:panelGrid>
                <p:spacer height="10" width="13" />
                <p:messages id="validarInfoMsgs" />
                <p:spacer height="10" width="13" />

                <p:outputPanel layout="block" style="text-align:center">
                    <p:commandButton value="Guardar" disabled="#{!radicacionActualizacion.banderaZipCargado}"
                                     update=":datosActualizacionForm:procesosActualizacionDT, validarInfoMsgs"
                                     action="#{radicacionActualizacion.iniciarValidacion}"
                                     onstart="statusDialog2.show();"
                                     oncomplete="handleCompleteSIC(xhr, status, args, validarInfoWV, false);statusDialog2.hide();"
                                     icon="ui-icon-check"/>
                    <p:spacer width="10" />
                    <p:commandButton value="Cancelar" icon="ui-icon-close"
                                     onclick="validarInfoWV.hide();" />
                </p:outputPanel>
                <p:spacer height="20" width="13" />
            </h:form>
        </p:dialog>

        <p:dialog header="Cargar archivos" dynamic="true"
                  widgetVar="cargarArchivosWV" modal="true" appendToBody="true"
                  resizable="true" position="center" width="500" height="180">
            <h:form id="cargarArchivosForm"> 

                <p:spacer height="10" width="13" />
                <p:messages id="cargarArchivosMsgs" />
                <p:spacer height="10" width="13" />



                <h:panelGrid columns="2" cellpadding="10">

                    <h:outputLabel value="Documento soporte: "
                                   styleClass="outputLabelStyle" />
                    <p:fileUpload id="fu" label="Cargar documento" style="width: 300px;"
                                  fileUploadListener="#{radicacionActualizacion.archivoUpload}" immediate="true"
                                  dragDropSupport="true" 
                                  invalidFileMessage="Formato de documento no permitido"
                                  invalidSizeMessage="El archivo seleccionado supera el tamaño permitido"
                                  widgetVar="uploader" mode="advanced" auto="true"
                                  sizeLimit="#{general.maximoTamanoAdjuntos}" allowTypes="/(\.|\/)(zip)$/"
                                  update="fu, :cargarArchivosForm" 
                                  onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();"/>

                </h:panelGrid>


                <p:outputPanel layout="block" style="text-align:center">
                    <p:commandButton value="Guardar" disabled="#{!radicacionActualizacion.banderaZipCargado}"
                                     update=":datosActualizacionForm:procesosActualizacionDT, cargarArchivosMsgs"
                                     action="#{radicacionActualizacion.cargarZipFTP}"
                                     onstart="statusDialog2.show();"
                                     oncomplete="handleCompleteSIC(xhr, status, args, cargarArchivosWV, false);statusDialog2.hide();"
                                     icon="ui-icon-check"/>
                    <p:spacer width="10" />
                    <p:commandButton value="Cancelar" icon="ui-icon-close"
                                     onclick="cargarArchivosWV.hide();" />
                </p:outputPanel>
                <p:spacer height="20" width="13" />
            </h:form>
        </p:dialog>

        <p:dialog header="Información radicación" dynamic="true"
                  widgetVar="radicarInfoWV" modal="true" appendToBody="true"
                  resizable="true" position="center" width="950" height="700">

            <ui:include src="/actualizacion/radicacionActualizacionDetalle.xhtml"/>

        </p:dialog>

        <misc:visualizadorMemorandosCC
            id="viewReport"
            thisWVName="visorReporteWV"
            urlDocumento="#{radicacionActualizacion.reporteBase.urlWebReporte}"
            fileContent="#{radicacionActualizacion.reporteBase.streamedContentReporte}"
            documentoGenerado="#{radicacionActualizacion.reporteBase ne null}"
            radicarButtonVisible="false" 
            cancelButtonEnabled="true"/>

    </ui:define>


</ui:composition>
